-- JOHN DEERE 3650
-- Autor: maciey
-- http://lstime.xaa.pl

jd3650 = {};

function jd3650.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function jd3650:load(xmlFile)

-- Swiatlo tyl --
      
    self.numtylneswiatla = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.tylneswiatla#count"), 0);
    self.tylneswiatla = {};
    for i=1, self.numtylneswiatla do
        local tylneswiatlonamei = string.format("vehicle.tylneswiatla.tylneswiatlo" .. "%d", i);
        self.tylneswiatla[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, tylneswiatlonamei .. "#index"));
        setVisibility(self.tylneswiatla[i], false);
		self.tylneswiatlaActive = false;
    end;	
	
-- Tylna szyba --
	
	local rotationPartNodetylnaszyba = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tylnaszyba#index"));
    if rotationPartNodetylnaszyba ~= nil then
        self.rotationParttylnaszyba = {};
        self.rotationParttylnaszyba.node = rotationPartNodetylnaszyba;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttylnaszyba#minRot"));
        self.rotationParttylnaszyba.minRot = {};
        self.rotationParttylnaszyba.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttylnaszyba.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttylnaszyba.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tylnaszyba#maxRot"));
        self.rotationParttylnaszyba.maxRot = {};
        self.rotationParttylnaszyba.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttylnaszyba.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttylnaszyba.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttylnaszyba.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tylnaszyba#rotTime"), 2)*1000;
        self.rotationParttylnaszyba.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tylnaszyba#touchRotLimit"), 10));
    end;
end;
	
function jd3650:keyEvent(unicode, sym, modifier, isDown)

-- Tylne swiatlo --

	if isDown and sym == Input.KEY_4 then
		self.tylneswiatlaActive = not self.tylneswiatlaActive;
	end;
	
-- Panel pomocy --
	
    if isDown and sym == Input.KEY_0 then
		self.helpPanel = not self.helpPanel;
	end;
	
-- Tylna szyba --
	
    if isDown and sym == Input.KEY_5 then 
		self.rotationMaxtylnaszyba = not self.rotationMaxtylnaszyba;
	end; 
end; 
	
function jd3650:update(dt)
    if self.isEntered then
	
-- Tylna szyba --
	
	    if self.rotationParttylnaszyba ~= nil then
		   local x, y, z = getRotation(self.rotationParttylnaszyba.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttylnaszyba.maxRot, self.rotationParttylnaszyba.minRot, 3, self.rotationParttylnaszyba.rotTime, dt, not self.rotationMaxtylnaszyba);
		   setRotation(self.rotationParttylnaszyba.node, unpack(newRot));
        end;

-- Swiatlo tyl --

	    if self.isEntered then
        if self.tylneswiatlaActive then
		   for i=1, self.numtylneswiatla do
		   local tylneswiatlo = self.tylneswiatla[i];
		   setVisibility(tylneswiatlo, self.tylneswiatlaActive);
		end;
	else
		for i=1, self.numtylneswiatla do
			local tylneswiatlo = self.tylneswiatla[i];
			setVisibility(tylneswiatlo, self.tylneswiatlaActive, false);
		end;
end;
end;
end;
end;
	
function jd3650:draw()

    if self.isEntered then
		if not self.helpPanel then
			renderText(0.8335, 0.15, 0.02, "0: Obsluga");
		else
			renderText(0.8335, 0.15, 0.02, "0: Obsluga");
		end;
		if self.helpPanel then
			renderText(0.72, 0.86, 0.025, "- JOHN DEERE 3650 -");
			renderText(0.72, 0.82, 0.02, "4: Tylna szyba");
			renderText(0.72, 0.80, 0.02, "5: Swiatla tyl");
		end;
	end;
end;

function jd3650:onEnter()
end;

function jd3650:onLeave()
end;

function jd3650:delete()
end;

function jd3650:mouseEvent(posX, posY, isDown, isUp, button)
end;